#include "../common/pch.h"


bool SDC_RTree::sky_dom_iter_All(float *_pt, int dom){
	bool ret = false;
	
	list<float>::iterator iter, fiter;
	
	
	// LOCAL RESULTS
//	cerr << "checking local " << sdc->local_result.size() << " results" << endl; 
	iter = sdc->local_result.begin();
	while (iter!=sdc->local_result.end()){
		fiter = iter;
		float *s_pt = new float[dimension];
		for (int j=0; j<dimension; j++){
			s_pt[j] = *fiter; 
			fiter++;
		}
		
		bool resultPointDeleted = false;
		
		if(dom == DOM){
			if(sdc->dominate(s_pt, _pt)){
				ret = true;
			}
			else if(sdc->dominate(_pt, s_pt)){
				cerr << "FALSE HIT" << endl;
				sdc->false_hits++;
				for (uint jj=0; jj<dimension; jj++){
					iter = sdc->local_result.erase(iter);
				}
				resultPointDeleted = true;
			}
		}
		
		
		if(dom == MDOM) {
			ret = sdc->m_dominate(dimension, s_pt, _pt);
		}
		
		delete[] s_pt;

		if(ret){
			return true;
		}
		
		if (!resultPointDeleted){
			for (uint jj=0; jj<dimension; jj++){
				iter++;
			}
		}	
	}
	
	
	// GLOBAL RESULTS
//	cerr << "checking global " << sdc->global_result.size() << " results" << endl;
	iter = sdc->global_result.begin();
	while (iter!=sdc->global_result.end()){
		float *s_pt = new float[dimension];
		for (int j=0; j<dimension; j++){
			s_pt[j] = *iter; 
			iter++;
		}
				
		if(dom == DOM){
			if(sdc->dominate(s_pt, _pt)){
				ret = true;
			}
		}
		
		
		if(dom == MDOM) {
			ret = sdc->m_dominate(dimension, s_pt, _pt);
		}
		
		delete[] s_pt;

		if(ret){
			return true;
		}
			
	}
	
	
	
	return ret;
}

bool SDC_RTree::sky_dom_iter(float *_pt, int dom){
	bool ret = false;
	
	list<float>::iterator iter, fiter;
	
	iter = sdc->local_result.begin();
	while (iter!=sdc->local_result.end()){
		fiter = iter;
		float *s_pt = new float[dimension];
		for (int j=0; j<dimension; j++){
			s_pt[j] = *fiter; 
			fiter++;
		}
		
		bool resultPointDeleted = false;
		
		if(dom == DOM){
			if(sdc->dominate(s_pt, _pt)){
				ret = true;
			}
			else if(sdc->dominate(_pt, s_pt)){
				sdc->false_hits++;
				for (uint jj=0; jj<dimension; jj++){
					iter = sdc->local_result.erase(iter);
				}
				resultPointDeleted = true;
			}
		}
		
		
		if(dom == MDOM) {
			ret = sdc->m_dominate(dimension, s_pt, _pt);
		}
		
		delete[] s_pt;

		if(ret){
			break;
		}
		
		if (!resultPointDeleted){
			for (uint jj=0; jj<dimension; jj++){
				iter++;
			}
		}	
	}
	return ret;
}


void SDC_RTree::skyline(XxkHeap *_hp){
	int i, j;

	HeapEntry *he=new HeapEntry();
	he->dim = dimension;
	he->son1 = root;
	he->key = 0;
	he->level = 1; //this is not important but make sure it is greater than 0
	he->bounces = new float[2 * dimension];
	for (j = 0; j < 2 * dimension; j++)
		he->bounces[j] = 0.0;
	_hp->push( he );

	float *b = new float[dimension];
	float *bounces = new float[dimension];

	while (_hp->empty() == false){
		he = _hp->top();
		_hp->pop();

		int son = he->son1;
		int level = he->level;

		for (i = 0; i < dimension; i ++){
				bounces[i] = he->bounces[2 * i];
		}

		if (level==0){
			if (!sky_dom_iter_All(bounces, DOM)){
				bool retu = false;
				/// check for dominance with globalResult
				
				/*
				int _dim = TO_dim + 2*PO_dim;
				list<float>::iterator giter = global_result.begin();
				while (giter!=global_result.end()){	
					float *gp = new float[_dim];
					for (j=0; j<_dim; j++){
						gp[j] = *giter; 
						giter++;
					}
					
					if(SDC_dominate(G, TO_dim, PO_dim, _dim, gp, bounces)){
						retu = true;
						SDC_false_hits++;
						delete gp;
						break;
					}
					delete gp;	
				}
				*/
				
				if(!retu){ // the point is not dominated
					for(j=0;j<dimension;j++){
//					cout << bounces[j] << " ";
						sdc->local_result.push_back(bounces[j]);
					}
					
				}
			}
		}
		else{
			if (!sky_dom_iter_All(bounces, MDOM)){
				RTNode *child = new RTNode(this, son);
				sdc->accesses++;
//				cerr << "IOs " << sdc->accesses << endl;

				for (i = 0; i < child->num_entries; i ++){
					for (j = 0; j < dimension; j ++) {
						b[j] = child->entries[i].bounces[2 * j];
					}
					
					if (!sky_dom_iter_All( b, MDOM)){
						HeapEntry *tmp_he = new HeapEntry();
						tmp_he->init_HeapEntry( dimension );
						tmp_he->son1 = child->entries[i].son;
						tmp_he->level = child->level;
						tmp_he->key = 0;

						for (j = 0; j < dimension; j ++){
							tmp_he->key += b[j]; // Manhattan distance
						}

						memcpy( tmp_he->bounces, child->entries[i].bounces, 2 * dimension * sizeof( float ) );
						_hp->push( tmp_he );
					}
				}
				delete child;
			}
		}
		delete he;
	}
	delete [] bounces;
	delete [] b;

	return;
}


