#ifndef TSS_RTREE_H_
#define TSS_RTREE_H_

class TSS;

class TSS_RTree : public RTree{
public:
	
	TSS *tss; // pointer to the TSS class
	
	bool sky_dom_iter(float* _pt);
	void skyline(XxkHeap *_hp);
	
	
	// constructors
	TSS_RTree(TSS *tss, const char *fname, int _b_length, Cache *c, int _dimension) : RTree(fname, _b_length, c, _dimension){
		this->tss = tss;
	};
	TSS_RTree(TSS *tss, const char *fname, Cache *c) : RTree(fname, c){
		this->tss = tss;
	};
	TSS_RTree(TSS *tss, const char *inpname, const char *fname, int _b_length, Cache *c, int _dimension) : RTree(inpname, fname, _b_length, c, _dimension){
		this->tss = tss;
	};
	
};


#endif /*TSS_RTREE_H_*/
