class Graph{

public:
	int encoding_size;
	int lattice_size; 
	int graph_size; 
	float node_prob;
	Node *nodes_table;			// All nodes in the original lattice
	int *TO_table;				// Table indicating the topological order of the nodes
	vector<vector<int> > *IT;	// Intervals table
	RTree **RT_SDC;				// Set of R-Trees in SDC
	map<int, int> invert_IT;	// Inverted index on IT  <interval_start, encoding>
	
	bool ***rangeDomnedByEnc;
	
	Graph(int, float);
	Graph(char* fileName, float ndp); // read from file
	bool covering(float);
	int covered(float);
	void createLattice();
	void createFinalGraph();
	void createST();
	void topologicalOrder();
	void createIntervalsTable_SDC();
	void labelNodesStrata();
	void createTrees_SDC();
	void skyline_SDC();
	void computePODominanceClosure();
	void computeRangeDomnedByEnc();
};
